﻿#region namespaces

using System;
using ZOIL.DataModel;

#endregion

namespace ZOIL.DataBackend.BaseX
{
    public class AcceptRemotelyCreatedObjectEventArgs : EventArgs
    {
        public bool Accept { get; set; }

        private readonly IPersistable _databasePersistable;

        public IPersistable DatabasePersistable
        {
            get { return _databasePersistable; }
        }

        private readonly IVisualProperties _visualProperties;

        public IVisualProperties VisualProperties
        {
            get { return _visualProperties; }
        }

        public AcceptRemotelyCreatedObjectEventArgs(IPersistable databasePersistable, IVisualProperties visualProperties)
        {
            _databasePersistable = databasePersistable;
            _visualProperties = visualProperties;
        }
    }
}