import module namespace functx = "http://www.functx.com"; 

declare function local:findNextExistingParent($context, $pathAsString)
{
  let $trimmedPath := functx:trim($pathAsString)
  return 
    if(string-length($trimmedPath) <= 0)
    then ("","")
    else 
      let $p := functx:dynamic-path($context, $trimmedPath)
      return 
        if(empty($p))
        then 
          let $parent := functx:substring-before-last($trimmedPath, "/")
          let $notExisting := functx:substring-after-last($trimmedPath, "/")
          let $tuple := local:findNextExistingParent($context, $parent)
          return ($tuple[1], if(string-length($tuple[2]) <= 0) then $notExisting else concat($tuple[2], "/", $notExisting))
        else ($trimmedPath ,"")
};
declare function local:createElementsByPath($nodesAsString, $content)
{
  if(string-length($nodesAsString) > 0)
  then
    let $current := functx:substring-before-if-contains($nodesAsString, "/")
    let $next := substring-after($nodesAsString, "/")
    return element { $current } { local:createElementsByPath($next, $content) }
  else
    $content
};
declare updating function local:insertNodeImpl($context, $pathAsString, $content)
{
  let $ex := local:findNextExistingParent($context, $pathAsString)
  let $existing := $ex[1]
  let $missing := $ex[2]
  let $insertStuff := local:createElementsByPath($missing, $content)
  return insert node $insertStuff into functx:dynamic-path($context, $existing)
};
declare updating function local:insertNode($databaseName, $pathAsString, $content)
{
  (:erst mal root namespace = document ermitteln:)
  let $rootName := substring-before($pathAsString, "/")
  return 
    if(db:exists($databaseName, $rootName))
    then
      local:insertNodeImpl(db:open($databaseName, $rootName), $pathAsString, $content)
    else
      (:Dokument erstellen:)
      db:add($databaseName, document { local:createElementsByPath($pathAsString, $content) }, $rootName)

};

(:create db test <root><foo><bla><blub/></bla></foo></root>:)
let $db := "TestStuff"
let $path := "root/juhuu/blablabla"
let $content := <hallo>Welt2</hallo>
return local:insertNode($db, $path, $content)
