﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ZOIL.DataModel;
using System.Windows;

namespace ZOIL.Library.Behaviors
{
    [ViewModelFor(typeof(ShapeToShapeConnectionView))]
    public class ShapeToShapeConnectionViewModel : BaseViewModel
    {
        #region ctor

        public ShapeToShapeConnectionViewModel()
        {
            RegisterChangeNotification("ConnectionPoint1", "ConnectionPoint1");
            RegisterChangeNotification("ConnectionPoint2", "ConnectionPoint2");
        }

        #endregion

        #region public properties

        #region ConnectionPoint1

        /// <summary>
        /// Gets or sets the ConnectionPoint1 property. This observable property 
        /// indicates
        /// </summary>
        public Point ConnectionPoint1
        {
            get { return (Model as ShapeToShapeConnection).ConnectionPoint1; }
            set
            {
                (Model as ShapeToShapeConnection).ConnectionPoint1 = value;
                RaisePropertyChangedEvent("ConnectionPoint1");
            }
        }

        #endregion

        #region ConnectionPoint2

        /// <summary>
        /// Gets or sets the ConnectionPoint2 property. This observable property 
        /// indicates
        /// </summary>
        public Point ConnectionPoint2
        {
            get { return (Model as ShapeToShapeConnection).ConnectionPoint2; }
            set
            {
                (Model as ShapeToShapeConnection).ConnectionPoint2 = value;
                RaisePropertyChangedEvent("ConnectionPoint2");
            }
        }

        #endregion

        #endregion
    }
}
