﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.Composition;
using ZOIL.Framework.Presentation;
using Bespoke.Common.Osc;
using System.Net;
using System.Windows;

namespace ZOIL.Library.Behaviors.Viewport
{
    [Export(typeof(SendViewportPluginBehavior))]
    public class SendViewportOSCBehavior : SendViewportPluginBehavior
    {
        #region ctor

        public SendViewportOSCBehavior() : base()
        {

        }

        #endregion

        private const string address = "/viewport";
        private readonly IPAddress senderIP = IPAddress.Parse("0.0.0.0");
        private readonly IPAddress targetIP = IPAddress.Parse("224.5.6.7");
        private const short port = 4411;

        private void sendViewportCommand(Rect viewport)
        {
            OscMessage msg = new OscMessage(new IPEndPoint(senderIP, port), address);
            msg.Append<double>(viewport.Left);
            msg.Append<double>(viewport.Top);
            msg.Append<double>(viewport.Width);
            msg.Append<double>(viewport.Height);

            if (!String.IsNullOrEmpty(SenderID))
                msg.Append<String>(SenderID);
            else
                msg.Append<String>("anonymous");

            msg.Send(new IPEndPoint(targetIP, port));
        }
        
        #region overrides

        protected override void OnViewportChanged(ZInformationLandscape l)
        {
            sendViewportCommand(l.Viewport);    
        }

        #endregion
    }
}
