﻿using ZOIL.DataBackend;

namespace ZOIL.Library.Components
{
    public class ZPortal : DInformationObject
    {
        #region ctor

        public ZPortal()
        {
            IsMagicLense = false;
            IsInitialized = false;
        }

        #endregion

        #region public properties

        #region IsMagicLense

        public bool IsMagicLense
        {
            get
            {
                return (bool)GetValue("zportal:ismagiclense");
            }
            set
            {
                SetValue("zportal:ismagiclense", value);
                RaisePropertyChangedEvent("IsMagicLense");
            }
        }

        #endregion

        #region IsInitialized

        public bool IsInitialized
        {
            get
            {
                return (bool)GetValue("zportal:isinitialized");
            }
            set
            {
                SetValue("zportal:isinitialized", value);
                RaisePropertyChangedEvent("IsInitialized");
            }
        }

        #endregion

        #region PortalShape

        public ZPortalShape PortalShape
        {
            get
            {
                return GetValue<ZPortalShape>("zportal:portalshape");
            }
            set
            {
                SetValue("zportal:portalshape", value);
                RaisePropertyChangedEvent("PortalShape");
            }
        }

        #endregion

        #endregion

        
    }
}
