﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ZOIL.DataBackend;

namespace ZOIL.Library.Components
{
    public class ZPhoto : DInformationObject, IRemoteUpdateable
    {
         public ZPhoto()
            : base()
        {

        }

         public String Title
         {
             get
             {
                 return GetValue<String>("zPhoto:title");
             }
             set
             {
                 SetValue("zPhoto:title", value);
                 RaisePropertyChangedEvent("Title");
             }
         }

         public IList<String> Tags
         {
             get
             {
                 return GetValue<IList<String>>("zPhoto:tags");
             }
             set
             {
                 SetValue("zPhoto:tags", value);
                 RaisePropertyChangedEvent("Tags");
             }
         }

         public String UserName
         {
             get
             {
                 return GetValue<String>("zPhoto:userName");
             }
             set
             {
                 SetValue("zPhoto:userName", value);
                 RaisePropertyChangedEvent("UserName");
             }
         }

         public String RealName
         {
             get
             {
                 return GetValue<String>("zPhoto:realName");
             }
             set
             {
                 SetValue("zPhoto:realName", value);
                 RaisePropertyChangedEvent("RealName");
             }
         }

         public String UserCountry
         {
             get
             {
                 return GetValue<String>("zPhoto:userCountry");
             }
             set
             {
                 SetValue("zPhoto:userCountry", value);
                 RaisePropertyChangedEvent("UserCountry");
             }
         }

         public String Description
         {
             get
             {
                 return GetValue<String>("zPhoto:description");
             }
             set
             {
                 SetValue("zPhoto:description", value);
                 RaisePropertyChangedEvent("Description");
             }
         }

         public Uri BuddyIconURL
         {
             get
             {
                 return GetValue<Uri>("zPhoto:buddyIconURL");
             }
             set
             {
                 SetValue("zPhoto:buddyIconURL", value);
                 RaisePropertyChangedEvent("BuddyIconURL");
             }
         }

         public DateTime DateUploaded
         {
             get
             {
                 return (DateTime)GetValue("zPhoto:dateUploaded");
             }
             set
             {
                 SetValue("zPhoto:dateUploaded", value);
                 RaisePropertyChangedEvent("DateUploaded");
             }
         }

         public int Views
         {
             get
             {
                 return (int)GetValue("zPhoto:views");
             }
             set
             {
                 SetValue("zPhoto:views", value);
                 RaisePropertyChangedEvent("Views");
             }
         }

        public String PhotoId
        {
            get
            {
                return GetValue<String>("zPhoto:photoId");
            }
            set
            {
                SetValue("zPhoto:photoId", value);
                RaisePropertyChangedEvent("PhotoId");
            }
        }

        public Uri SmallUrl
         {
             get
             {
                 return GetValue<Uri>("zPhoto:smallUrl");
             }
             set
             {
                 SetValue("zPhoto:smallUrl", value);
                 RaisePropertyChangedEvent("SmallUrl");
             }
         }

        #region IRemoteUpdateable Members

        public void OnRemoteUpdate()
        {
            RaisePropertyChangedEvent("Title");
        }

        #endregion

    }
}