﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ZOIL.DataModel;
using ZOIL.Framework.Presentation;
using System.Windows.Threading;
using System.Diagnostics;
using System.Windows.Ink;
using System.Globalization;
using System.Windows.Markup;
using System.Windows.Media.Animation;
using ZOIL.Framework.Core;

namespace ZOIL.Library.Components
{
    /// <summary>
    /// Interaction logic for ZPhotoView.xaml
    /// </summary>
    [ViewFor(typeof(ZPhoto), "default")]
    public partial class ZPhotoView : ZComponent
    {
        private static Random _rnd = new Random();

        public ZPhotoView() : base()
        {
            InitializeComponent();
            //this.Rotate.Angle = (_rnd.NextDouble() * 20) - 10;
        }

        private void ZComponent_MouseDown(object sender, MouseButtonEventArgs e)
        {
            ((Storyboard)FindResource("MouseDownStoryBoard")).Begin();
        }

        private void ZComponent_MouseUp(object sender, MouseButtonEventArgs e)
        {
            ((Storyboard)FindResource("MouseUpStoryBoard")).Begin();
        }

        private void HandleTabOnButton(object sender, Microsoft.Surface.Presentation.ContactEventArgs e)
        {
            e.Handled = true;
        }
    }

    #region String Concatenator

    public class StringConcatenator : ConverterMarkupExtension<StringConcatenator>, IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {

            if (value != null)
            {
                IList<String> stringList = (IList<String>)value;
                String separator = "; ";
                if (parameter != null)
                {
                    separator = parameter.ToString() + " ";
                }
                String concatenatedString = stringList[0];

                for (int i = 1; i < stringList.Count; i++)
                {
                    concatenatedString = concatenatedString + separator + stringList[i];
                }

                return concatenatedString;
            }
            else
            {
                return null;
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }

    #endregion
}
