﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ZOIL.DataModel;
using System.Windows.Input;
using System.Windows;
using ZOIL.Framework.Presentation;
using ZOIL.Library.Devices.OSC;
using Microsoft.Surface.Presentation.Controls;
using System.Windows.Controls;
using System.Windows.Media;

namespace ZOIL.Library.Components
{
    public class CardViewModel : BaseViewModel
    {

        public CardViewModel()
            : base()
        {
            RegisterChangeNotification("ProID", "ProID");
            RegisterChangeNotification("CategoryID", "CategoryID");
            RegisterChangeNotification("CardID", "CardID");
            RegisterChangeNotification("Topic", "Topic");
            RegisterChangeNotification("LogoUrl", "LogoUrl");
            RegisterChangeNotification("TextureUrl", "TextureUrl");
            RegisterChangeNotification("LeftID", "LeftID");
            RegisterChangeNotification("RightID", "RightID");
            RegisterChangeNotification("TopID", "TopID");
            RegisterChangeNotification("BottomID", "BottomID");
            RegisterChangeNotification("FakeZoomLevelIn", "FakeZoomLevelIn");
            RegisterChangeNotification("FakeZoomLevelOut", "FakeZoomLevelOut");
        }

        #region Properties

        public int? ProID
        {
            get
            {
                return (Model as Card).ProID;
            }
            set
            {
                (Model as Card).ProID = value;
                RaisePropertyChangedEvent("ProID");
            }
        }

        public int? CategoryID
        {
            get
            {
                return (Model as Card).CategoryID;
            }
            set
            {
                (Model as Card).CategoryID = value;
                RaisePropertyChangedEvent("CategoryID");
            }
        }

        //public Visibility Visible
        //{
        //    get
        //    {
        //        return (Model as Card).Visible;
        //    }
        //    set
        //    {
        //        (Model as Card).Visible = value;
        //        RaisePropertyChangedEvent("Visible");
        //    }
        //}

        public int? CardID
        {
            get
            {
                return (Model as Card).CardID;
            }
            set
            {
                (Model as Card).CardID = value;
                RaisePropertyChangedEvent("CardID");
            }
        }

        public int? Topic
        {
            get
            {
                return (Model as Card).Topic;
            }
            set
            {
                (Model as Card).Topic = value;
                RaisePropertyChangedEvent("Topic");
            }
        }

        public Uri LogoUrl
        {
            get
            {
                return new Uri((Model as Card).LogoUrl);
            }
            set
            {
                (Model as Card).LogoUrl = value.ToString();
                RaisePropertyChangedEvent("LogoUrl");
            }
        }

        public Uri TextureUrl
        {
            get
            {
                return new Uri((Model as Card).TextureUrl);
            }
            set
            {
                (Model as Card).TextureUrl = value.ToString();
                RaisePropertyChangedEvent("TextureUrl");
            }
        }

        public int? LeftID
        {
            get
            {
                return (Model as Card).LeftID;
            }
            set
            {
                (Model as Card).LeftID = value;
                RaisePropertyChangedEvent("LeftID");
            }
        }

        public int? RightID
        {
            get
            {
                return (Model as Card).RightID;
            }
            set
            {
                (Model as Card).RightID = value;
                RaisePropertyChangedEvent("RightID");
            }
        }

        public int? TopID
        {
            get
            {
                return (Model as Card).TopID;
            }
            set
            {
                (Model as Card).TopID = value;
                RaisePropertyChangedEvent("TopID");
            }
        }

        public int? BottomID
        {
            get
            {
                return (Model as Card).BottomID;
            }
            set
            {
                (Model as Card).BottomID = value;
                RaisePropertyChangedEvent("BottomID");
            }
        }

        public int? FakeZoomLevelOut
        {
            get
            {
                return (Model as Card).FakeZoomLevelOut;
            }
            set
            {
                (Model as Card).FakeZoomLevelOut = value;
                RaisePropertyChangedEvent("FakeZoomLevelOut");
            }
        }

        public int? FakeZoomLevelIn
        {
            get
            {
                return (Model as Card).FakeZoomLevelIn;
            }
            set
            {
                (Model as Card).FakeZoomLevelIn = value;
                RaisePropertyChangedEvent("FakeZoomLevelIn");
            }
        }

        #endregion

    }
}
