﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ZOIL.DataModel;
using System.Windows.Input;
using System.Windows;
using ZOIL.Framework.Presentation;
using ZOIL.Library.Devices.OSC;
using Microsoft.Surface.Presentation.Controls;
using System.Windows.Controls;
using System.Windows.Media;

namespace ZOIL.Library.Components
{
    [ViewModelFor(typeof(LogoCardView))]
    public class LogoCardViewModel : BaseViewModel
    {

        public LogoCardViewModel()
            : base()
        {
            RegisterChangeNotification("ZoomLevel2", "ZoomLevel2");

            RegisterChangeNotification("ProID", "ProID");
            RegisterChangeNotification("CategoryID", "CategoryID");
            RegisterChangeNotification("CardID", "CardID");
            RegisterChangeNotification("Topic", "Topic");
            RegisterChangeNotification("LogoUrl", "LogoUrl");
            RegisterChangeNotification("TextureUrl", "TextureUrl");
            RegisterChangeNotification("LeftID", "LeftID");
            RegisterChangeNotification("RightID", "RightID");
            RegisterChangeNotification("TopID", "TopID");
            RegisterChangeNotification("BottomID", "BottomID");
            RegisterChangeNotification("FakeZoomLevelIn", "FakeZoomLevelIn");
            RegisterChangeNotification("FakeZoomLevelOut", "FakeZoomLevelOut");
        }

        public new LogoCard Model
        {
            get
            {
                return base.Model as LogoCard;
            }
            set
            {
                base.Model = value;
            }
        }

        public new object BaseModel
        {
            get
            {
                return base.Model;
            }
            set
            {
                base.Model = value;
            }
        }

        #region Properties

        public int? ProID
        {
            get
            {
                return (Model as LogoCard).ProID;
            }
            set
            {
                (Model as LogoCard).ProID = value;
                RaisePropertyChangedEvent("ProID");
            }
        }

        public int? CategoryID
        {
            get
            {
                return (Model as LogoCard).CategoryID;
            }
            set
            {
                (Model as LogoCard).CategoryID = value;
                RaisePropertyChangedEvent("CategoryID");
            }
        }

        public int? ZoomLevel1
        {
            get
            {
                return (Model as LogoCard).ZoomLevel1;
            }
            set
            {
                (Model as LogoCard).ZoomLevel1 = value;
                RaisePropertyChangedEvent("ZoomLevel1");
            }
        }

        public int? ZoomLevel2
        {
            get
            {
                return (Model as LogoCard).ZoomLevel2;
            }
            set
            {
                (Model as LogoCard).ZoomLevel2 = value;
                RaisePropertyChangedEvent("ZoomLevel2");
            }
        }

        public int? CardID
        {
            get
            {
                return (Model as LogoCard).CardID;
            }
            set
            {
                (Model as LogoCard).CardID = value;
                RaisePropertyChangedEvent("CardID");
            }
        }

        public int? Topic
        {
            get
            {
                return (Model as LogoCard).Topic;
            }
            set
            {
                (Model as LogoCard).Topic = value;
                RaisePropertyChangedEvent("Topic");
            }
        }

        public Uri LogoUrl
        {
            get
            {
                return new Uri((Model as LogoCard).LogoUrl);
            }
            set
            {
                (Model as LogoCard).LogoUrl = value.ToString();
                RaisePropertyChangedEvent("LogoUrl");
            }
        }

        public Uri TextureUrl
        {
            get
            {
                return new Uri((Model as LogoCard).TextureUrl);
            }
            set
            {
                (Model as LogoCard).TextureUrl = value.ToString();
                RaisePropertyChangedEvent("TextureUrl");
            }
        }

        public int? LeftID
        {
            get
            {
                return (Model as LogoCard).LeftID;
            }
            set
            {
                (Model as LogoCard).LeftID = value;
                RaisePropertyChangedEvent("LeftID");
            }
        }

        public int? RightID
        {
            get
            {
                return (Model as LogoCard).RightID;
            }
            set
            {
                (Model as LogoCard).RightID = value;
                RaisePropertyChangedEvent("RightID");
            }
        }

        public int? TopID
        {
            get
            {
                return (Model as LogoCard).TopID;
            }
            set
            {
                (Model as LogoCard).TopID = value;
                RaisePropertyChangedEvent("TopID");
            }
        }

        public int? BottomID
        {
            get
            {
                return (Model as LogoCard).BottomID;
            }
            set
            {
                (Model as LogoCard).BottomID = value;
                RaisePropertyChangedEvent("BottomID");
            }
        }

        public int? FakeZoomLevelOut
        {
            get
            {
                return (Model as LogoCard).FakeZoomLevelOut;
            }
            set
            {
                (Model as LogoCard).FakeZoomLevelOut = value;
                RaisePropertyChangedEvent("FakeZoomLevelOut");
            }
        }

        public int? FakeZoomLevelIn
        {
            get
            {
                return (Model as LogoCard).FakeZoomLevelIn;
            }
            set
            {
                (Model as LogoCard).FakeZoomLevelIn = value;
                RaisePropertyChangedEvent("FakeZoomLevelIn");
            }
        }

        #endregion Properties
    }

}