﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ZOIL.DataBackend;
using System.Windows.Media;
using ZOIL.DataModel;
using ZOIL.Framework.Presentation;

namespace ZOIL.Library.Components
{
    public class MovieCard : DInformationObject, IRemoteUpdateable, Card
    {
        public MovieCard()
            : base()
        {

        }

        #region Properties

        public int? ProID
        {
            get
            {
                return (int?)GetValue("MovieCard:ProID");
            }
            set
            {
                SetValue("MovieCard:ProID", value);
                RaisePropertyChangedEvent("ProID");
            }
        }

        public int? CategoryID
        {
            get
            {
                return (int?)GetValue("MovieCard:CategoryID");
            }
            set
            {
                SetValue("MovieCard:CategoryID", value);
                RaisePropertyChangedEvent("CategoryID");
            }
        }

        public int? ZoomLevel1
        {
            get
            {
                return (int?)GetValue("MovieCard:ZoomLevel1");
            }
            set
            {
                SetValue("MovieCard:ZoomLevel1", value);
                RaisePropertyChangedEvent("ZoomLevel1");
            }
        }

        public int? ZoomLevel2
        {
            get
            {
                return (int?)GetValue("MovieCard:ZoomLevel2");
            }
            set
            {
                SetValue("MovieCard:ZoomLevel2", value);
                RaisePropertyChangedEvent("ZoomLevel2");
            }
        }

        public String Title
        {
            get
            {
                return GetValue<String>("MovieCard:Title");
            }
            set
            {
                SetValue("MovieCard:Title", value);
                RaisePropertyChangedEvent("Title");
            }
        }

        public String MovieUrl
        {
            get
            {
                return GetValue<String>("MovieCard:MovieUrl");
            }
            set
            {
                SetValue("MovieCard:MovieUrl", value);
                RaisePropertyChangedEvent("MovieUrl");
            }
        }

        public int? CardID
        {
            get
            {
                return (int?)GetValue("MovieCard:CardID");
            }
            set
            {
                SetValue("MovieCard:CardID", value);
                RaisePropertyChangedEvent("CardID");
            }
        }

        public int? FakeZoomLevelOut
        {
            get
            {
                return (int?)GetValue("MovieCard:FakeZoomLevelOut");
            }
            set
            {
                SetValue("MovieCard:FakeZoomLevelOut", value);
                RaisePropertyChangedEvent("FakeZoomLevelOut");
            }
        }

        public int? FakeZoomLevelIn
        {
            get
            {
                return (int?)GetValue("MovieCard:FakeZoomLevelIn");
            }
            set
            {
                SetValue("MovieCard:FakeZoomLevelIn", value);
                RaisePropertyChangedEvent("FakeZoomLevelIn");
            }
        }

        public int? Topic
        {
            get
            {
                return (int?)GetValue("MovieCard:Topic");
            }
            set
            {
                SetValue("MovieCard:Topic", value);
                RaisePropertyChangedEvent("Topic");
            }
        }

        public String LogoUrl
        {
            get
            {
                return GetValue<String>("MovieCard:LogoUrl");
            }
            set
            {
                SetValue("MovieCard:LogoUrl", value);
                RaisePropertyChangedEvent("LogoUrl");
            }
        }

        public String TextureUrl
        {
            get
            {
                return GetValue<String>("MovieCard:TextureUrl");
            }
            set
            {
                SetValue("MovieCard:TextureUrl", value);
                RaisePropertyChangedEvent("TextureUrl");
            }
        }

        public int? LeftID
        {
            get
            {
                return (int?)GetValue("MovieCard:LeftID");
            }
            set
            {
                SetValue("MovieCard:LeftID", value);
                RaisePropertyChangedEvent("LeftID");
            }
        }

        public int? RightID
        {
            get
            {
                return (int?)GetValue("MovieCard:RightID");
            }
            set
            {
                SetValue("MovieCard:RightID", value);
                RaisePropertyChangedEvent("RightID");
            }
        }

        public int? TopID
        {
            get
            {
                return (int?)GetValue("MovieCard:TopID");
            }
            set
            {
                SetValue("MovieCard:TopID", value);
                RaisePropertyChangedEvent("TopID");
            }
        }

        public int? BottomID
        {
            get
            {
                return (int?)GetValue("MovieCard:BottomID");
            }
            set
            {
                SetValue("MovieCard:BottomID", value);
                RaisePropertyChangedEvent("BottomID");
            }
        }

        #endregion Properties

        #region IRemoteUpdateable Members

        public void OnRemoteUpdate()
        {
            
        }

        #endregion

        #region Card Members


        private ZID _parent;

        public ZID ParentZID
        {
            get
            {
                return _parent;
            }
            set
            {
                _parent = value;
            }
        }


        private bool _onScreen;

        public bool onScreen
        {
            get
            {
                return _onScreen;
            }
            set
            {
                _onScreen = value;
            }
        }

        public new ZID ID
        {
            get
            {
                return base.ID;
            }
            set
            {
                base.ID = value;
            }
        }

        #endregion
    }
}