﻿using System;
using ZOIL.DataBackend;
using ZOIL.DataModel;
using ZOIL.Framework.Presentation;

namespace ZOIL.Library.Components
{
    public class TopicCard : DInformationObject, IRemoteUpdateable, Card
    {
        public TopicCard()
            : base()
        {

        }

        #region Properties

        public int? ZoomLevel1
        {
            get
            {
                return (int?)GetValue("TopicCard:ZoomLevel1");
            }
            set
            {
                SetValue("TopicCard:ZoomLevel1", value);
                RaisePropertyChangedEvent("ZoomLevel1");
            }
        }

        public int? ZoomLevel2
        {
            get
            {
                return (int?)GetValue("TopicCard:ZoomLevel2");
            }
            set
            {
                SetValue("TopicCard:ZoomLevel2", value);
                RaisePropertyChangedEvent("ZoomLevel2");
            }
        }


        public String Text
        {
            get
            {
                return GetValue<String>("TopicCard:Text");
            }
            set
            {
                SetValue("TopicCard:Text", value);
                RaisePropertyChangedEvent("Text");
            }
        }

        public double? TextFontSize
        {
            get
            {
                return (double?)GetValue("TopicCard:TextFontSize");
            }
            set
            {
                SetValue("TopicCard:TextFontSize", value);
                RaisePropertyChangedEvent("TextFontSize");
            }
        }

        public int? ProID
        {
            get
            {
                return (int?)GetValue("TopicCard:ProID");
            }
            set
            {
                SetValue("TopicCard:ProID", value);
                RaisePropertyChangedEvent("ProID");
            }
        }

        public int? CategoryID
        {
            get
            {
                return (int?)GetValue("TopicCard:CategoryID");
            }
            set
            {
                SetValue("TopicCard:CategoryID", value);
                RaisePropertyChangedEvent("CategoryID");
            }
        }

        public int? CardID
        {
            get
            {
                return (int?)GetValue("TopicCard:CardID");
            }
            set
            {
                SetValue("TopicCard:CardID", value);
                RaisePropertyChangedEvent("CardID");
            }
        }

        public int? FakeZoomLevelOut
        {
            get
            {
                return (int?)GetValue("TopicCard:FakeZoomLevelOut");
            }
            set
            {
                SetValue("TopicCard:FakeZoomLevelOut", value);
                RaisePropertyChangedEvent("FakeZoomLevelOut");
            }
        }

        public int? FakeZoomLevelIn
        {
            get
            {
                return (int?)GetValue("TopicCard:FakeZoomLevelIn");
            }
            set
            {
                SetValue("TopicCard:FakeZoomLevelIn", value);
                RaisePropertyChangedEvent("FakeZoomLevelIn");
            }
        }

        public int? Topic
        {
            get
            {
                return (int?)GetValue("TopicCard:Topic");
            }
            set
            {
                SetValue("TopicCard:Topic", value);
                RaisePropertyChangedEvent("Topic");
            }
        }

        public String LogoUrl
        {
            get
            {
                return GetValue<String>("TopicCard:LogoUrl");
            }
            set
            {
                SetValue("TopicCard:LogoUrl", value);
                RaisePropertyChangedEvent("LogoUrl");
            }
        }

        public String TextureUrl
        {
            get
            {
                return GetValue<String>("TopicCard:TextureUrl");
            }
            set
            {
                SetValue("TopicCard:TextureUrl", value);
                RaisePropertyChangedEvent("TextureUrl");
            }
        }

        public int? LeftID
        {
            get
            {
                return (int?)GetValue("TopicCard:LeftID");
            }
            set
            {
                SetValue("TopicCard:LeftID", value);
                RaisePropertyChangedEvent("LeftID");
            }
        }

        public int? RightID
        {
            get
            {
                return (int?)GetValue("TopicCard:RightID");
            }
            set
            {
                SetValue("TopicCard:RightID", value);
                RaisePropertyChangedEvent("RightID");
            }
        }

        public int? TopID
        {
            get
            {
                return (int?)GetValue("TopicCard:TopID");
            }
            set
            {
                SetValue("TopicCard:TopID", value);
                RaisePropertyChangedEvent("TopID");
            }
        }

        public int? BottomID
        {
            get
            {
                return (int?)GetValue("TopicCard:BottomID");
            }
            set
            {
                SetValue("TopicCard:BottomID", value);
                RaisePropertyChangedEvent("BottomID");
            }
        }

        #endregion Properties


        #region IRemoteUpdateable Members

        public void OnRemoteUpdate()
        {
           
        }

        #endregion

        #region Card Members


        private ZID _parent;

        public ZID ParentZID
        {
            get
            {
                return _parent;
            }
            set
            {
                _parent = value;
            }
        }



        private bool _onScreen;

        public bool onScreen
        {
            get
            {
                return _onScreen;
            }
            set
            {
                _onScreen = value;
            }
        }

        public new ZID ID
        {
            get
            {
                return base.ID;
            }
            set
            {
                base.ID = value;
            }
        }

        #endregion
    }
}